<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>magpar: init/elevertvol.c Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<!-- Generated by Doxygen 1.6.3 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Data&nbsp;Structures</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.html"><span>File&nbsp;List</span></a></li>
      <li><a href="globals.html"><span>Globals</span></a></li>
    </ul>
  </div>
  <div class="navpath"><a class="el" href="dir_f813120d4be15aaed9e35a3518d2a85e.html">init</a>
  </div>
</div>
<div class="contents">
<h1>elevertvol.c</h1><a href="elevertvol_8c.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">    This file is part of magpar.</span>
<a name="l00003"></a>00003 <span class="comment"></span>
<a name="l00004"></a>00004 <span class="comment">    Copyright (C) 2002-2010 Werner Scholz</span>
<a name="l00005"></a>00005 <span class="comment"></span>
<a name="l00006"></a>00006 <span class="comment">    www:   http://www.magpar.net/</span>
<a name="l00007"></a>00007 <span class="comment">    email: magpar(at)magpar.net</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">    magpar is free software; you can redistribute it and/or modify</span>
<a name="l00010"></a>00010 <span class="comment">    it under the terms of the GNU General Public License as published by</span>
<a name="l00011"></a>00011 <span class="comment">    the Free Software Foundation; either version 2 of the License, or</span>
<a name="l00012"></a>00012 <span class="comment">    (at your option) any later version.</span>
<a name="l00013"></a>00013 <span class="comment"></span>
<a name="l00014"></a>00014 <span class="comment">    magpar is distributed in the hope that it will be useful,</span>
<a name="l00015"></a>00015 <span class="comment">    but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00016"></a>00016 <span class="comment">    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the</span>
<a name="l00017"></a>00017 <span class="comment">    GNU General Public License for more details.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">    You should have received a copy of the GNU General Public License</span>
<a name="l00020"></a>00020 <span class="comment">    along with magpar; if not, write to the Free Software</span>
<a name="l00021"></a>00021 <span class="comment">    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00022"></a>00022 <span class="comment">*/</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Id[] = <span class="stringliteral">&quot;$Id: elevertvol.c 2962 2010-02-04 19:50:44Z scholz $\n\n&quot;</span>;
<a name="l00025"></a>00025 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Td[] = <span class="stringliteral">&quot;$Today: &quot;</span> __FILE__ <span class="stringliteral">&quot;  &quot;</span> __DATE__ <span class="stringliteral">&quot;  &quot;</span>  __TIME__  <span class="stringliteral">&quot; $\n\n&quot;</span>;
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="init_8h.html">init.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="util_8h.html">util/util.h</a>&quot;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a><a class="code" href="init_8h.html#add57a81e67724a47fc306e81ccec2a5e">00030</a> PetscReal <a class="code" href="elevertvol_8c.html#add57a81e67724a47fc306e81ccec2a5e">tetgrad</a>(PetscReal *x1,PetscReal *x2,PetscReal *x3,PetscReal *x4,PetscReal D_etaj[][<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>])
<a name="l00031"></a>00031 {
<a name="l00032"></a>00032   PetscReal t_elevol;
<a name="l00033"></a>00033 
<a name="l00034"></a>00034   t_elevol=<a class="code" href="init_8h.html#ad362da888961433eb994e6a5bc0c818d">tetvol</a>(x1,x2,x3,x4);
<a name="l00035"></a>00035 
<a name="l00036"></a>00036   <span class="comment">/* calculate gradients */</span>
<a name="l00037"></a>00037   D_etaj[0][0]=-(x3[1]*x2[2]-x4[1]*x2[2]-x2[1]*x3[2]+x4[1]*x3[2]+x2[1]*x4[2]-x3[1]*x4[2]);
<a name="l00038"></a>00038   D_etaj[0][1]=+(x3[0]*x2[2]-x4[0]*x2[2]-x2[0]*x3[2]+x4[0]*x3[2]+x2[0]*x4[2]-x3[0]*x4[2]);
<a name="l00039"></a>00039   D_etaj[0][2]=-(x3[0]*x2[1]-x4[0]*x2[1]-x2[0]*x3[1]+x4[0]*x3[1]+x2[0]*x4[1]-x3[0]*x4[1]);
<a name="l00040"></a>00040 
<a name="l00041"></a>00041   D_etaj[1][0]=+(x4[1]*x3[2]-x1[1]*x3[2]-x3[1]*x4[2]+x1[1]*x4[2]+x3[1]*x1[2]-x4[1]*x1[2]);
<a name="l00042"></a>00042   D_etaj[1][1]=-(x4[0]*x3[2]-x1[0]*x3[2]-x3[0]*x4[2]+x1[0]*x4[2]+x3[0]*x1[2]-x4[0]*x1[2]);
<a name="l00043"></a>00043   D_etaj[1][2]=+(x4[0]*x3[1]-x1[0]*x3[1]-x3[0]*x4[1]+x1[0]*x4[1]+x3[0]*x1[1]-x4[0]*x1[1]);
<a name="l00044"></a>00044 
<a name="l00045"></a>00045   D_etaj[2][0]=-(x1[1]*x4[2]-x2[1]*x4[2]-x4[1]*x1[2]+x2[1]*x1[2]+x4[1]*x2[2]-x1[1]*x2[2]);
<a name="l00046"></a>00046   D_etaj[2][1]=+(x1[0]*x4[2]-x2[0]*x4[2]-x4[0]*x1[2]+x2[0]*x1[2]+x4[0]*x2[2]-x1[0]*x2[2]);
<a name="l00047"></a>00047   D_etaj[2][2]=-(x1[0]*x4[1]-x2[0]*x4[1]-x4[0]*x1[1]+x2[0]*x1[1]+x4[0]*x2[1]-x1[0]*x2[1]);
<a name="l00048"></a>00048 
<a name="l00049"></a>00049   D_etaj[3][0]=+(x2[1]*x1[2]-x3[1]*x1[2]-x1[1]*x2[2]+x3[1]*x2[2]+x1[1]*x3[2]-x2[1]*x3[2]);
<a name="l00050"></a>00050   D_etaj[3][1]=-(x2[0]*x1[2]-x3[0]*x1[2]-x1[0]*x2[2]+x3[0]*x2[2]+x1[0]*x3[2]-x2[0]*x3[2]);
<a name="l00051"></a>00051   D_etaj[3][2]=+(x2[0]*x1[1]-x3[0]*x1[1]-x1[0]*x2[1]+x3[0]*x2[1]+x1[0]*x3[1]-x2[0]*x3[1]);
<a name="l00052"></a>00052 
<a name="l00053"></a>00053   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0;i&lt;<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>;i++) {
<a name="l00054"></a>00054     <span class="keywordflow">for</span> (<span class="keywordtype">int</span> j=0;j&lt;ND;j++) {
<a name="l00055"></a>00055       D_etaj[i][j] /= 6.0*t_elevol;
<a name="l00056"></a>00056     }
<a name="l00057"></a>00057   }
<a name="l00058"></a>00058 
<a name="l00059"></a>00059   <span class="comment">/* sum of gradients has to be zero in each element, proof!? */</span>
<a name="l00060"></a>00060   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> j=0;j&lt;ND;j++) {
<a name="l00061"></a>00061     <span class="keywordflow">if</span> (PetscAbsReal(D_etaj[0][j]+D_etaj[1][j]+D_etaj[2][j]+D_etaj[3][j])&gt;=<a class="code" href="griddata_8h.html#a26ab586dda1b8c780aa849e457c0cbad">D_EPS</a>*1000) {
<a name="l00062"></a>00062       PetscPrintf(PETSC_COMM_WORLD,
<a name="l00063"></a>00063         <span class="stringliteral">&quot;etaj: %g %g %g %g sum= %g\n&quot;</span>,
<a name="l00064"></a>00064         D_etaj[0][j],D_etaj[1][j],D_etaj[2][j],D_etaj[3][j],
<a name="l00065"></a>00065         D_etaj[0][j]+D_etaj[1][j]+D_etaj[2][j]+D_etaj[3][j]
<a name="l00066"></a>00066       );
<a name="l00067"></a>00067     }
<a name="l00068"></a>00068   }
<a name="l00069"></a>00069 
<a name="l00070"></a>00070   <span class="keywordflow">return</span>(0);
<a name="l00071"></a>00071 }
<a name="l00072"></a>00072 
<a name="l00073"></a>00073 
<a name="l00074"></a><a class="code" href="elevertvol_8c.html#aef5a137b230e99388bfdb98e300fb741">00074</a> PetscReal <a class="code" href="elevertvol_8c.html#aef5a137b230e99388bfdb98e300fb741">tetqual</a>(PetscReal *x1,PetscReal *x2,PetscReal *x3,PetscReal *x4)
<a name="l00075"></a>00075 {
<a name="l00076"></a>00076   PetscReal result;
<a name="l00077"></a>00077 
<a name="l00078"></a>00078   <span class="comment">/* calculate ratio of the volume of the current element and the volume</span>
<a name="l00079"></a>00079 <span class="comment">     of a regular tetrahedron whose edge length is the average over all</span>
<a name="l00080"></a>00080 <span class="comment">     six edges of the current tetrahedron</span>
<a name="l00081"></a>00081 <span class="comment">     formulas: http://www.linmpi.mpg.de/~daly/CSDS/t4h/tetra.htm</span>
<a name="l00082"></a>00082 <span class="comment"></span>
<a name="l00083"></a>00083 <span class="comment">     cf. VO Schrefl, Numerische Methoden, p. 44</span>
<a name="l00084"></a>00084 <span class="comment">  */</span>
<a name="l00085"></a>00085 
<a name="l00086"></a>00086   result=<a class="code" href="init_8h.html#ad362da888961433eb994e6a5bc0c818d">tetvol</a>(x1,x2,x3,x4)/(sqrt(2.0)/12.0*
<a name="l00087"></a>00087     pow(
<a name="l00088"></a>00088       (
<a name="l00089"></a>00089         sqrt((x1[0]-x2[0])*(x1[0]-x2[0])+(x1[1]-x2[1])*(x1[1]-x2[1])+(x1[2]-x2[2])*(x1[2]-x2[2]))+
<a name="l00090"></a>00090         sqrt((x1[0]-x3[0])*(x1[0]-x3[0])+(x1[1]-x3[1])*(x1[1]-x3[1])+(x1[2]-x3[2])*(x1[2]-x3[2]))+
<a name="l00091"></a>00091         sqrt((x1[0]-x4[0])*(x1[0]-x4[0])+(x1[1]-x4[1])*(x1[1]-x4[1])+(x1[2]-x4[2])*(x1[2]-x4[2]))+
<a name="l00092"></a>00092         sqrt((x2[0]-x3[0])*(x2[0]-x3[0])+(x2[1]-x3[1])*(x2[1]-x3[1])+(x2[2]-x3[2])*(x2[2]-x3[2]))+
<a name="l00093"></a>00093         sqrt((x2[0]-x4[0])*(x2[0]-x4[0])+(x2[1]-x4[1])*(x2[1]-x4[1])+(x2[2]-x4[2])*(x2[2]-x4[2]))+
<a name="l00094"></a>00094         sqrt((x3[0]-x4[0])*(x3[0]-x4[0])+(x3[1]-x4[1])*(x3[1]-x4[1])+(x3[2]-x4[2])*(x3[2]-x4[2]))
<a name="l00095"></a>00095       )/6.0,
<a name="l00096"></a>00096       3.0
<a name="l00097"></a>00097     )
<a name="l00098"></a>00098   );
<a name="l00099"></a>00099 
<a name="l00100"></a>00100   <span class="keywordflow">return</span>(result);
<a name="l00101"></a>00101 }
<a name="l00102"></a>00102 
<a name="l00103"></a>00103 
<a name="l00104"></a><a class="code" href="elevertvol_8c.html#a84b0acadfde91d8c984091ed850ab6bf">00104</a> PetscReal <a class="code" href="elevertvol_8c.html#a84b0acadfde91d8c984091ed850ab6bf">edgestat</a>(<span class="keywordtype">int</span> nele,<span class="keywordtype">int</span> *ele,PetscReal *xyz,PetscReal *min,PetscReal *max,PetscReal *avg)
<a name="l00105"></a>00105 {
<a name="l00106"></a>00106   PetscReal   *x1,*x2,*x3,*x4;
<a name="l00107"></a>00107   PetscReal   edge[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>];
<a name="l00108"></a>00108   PetscReal   elen;
<a name="l00109"></a>00109   PetscReal   elenavg=0;
<a name="l00110"></a>00110   PetscReal   elenmin=PETSC_MAX;
<a name="l00111"></a>00111   PetscReal   elenmax=PETSC_MIN;
<a name="l00112"></a>00112 
<a name="l00113"></a>00113   <a class="code" href="griddata_8h.html#a4e81d68a7df0ff55ea65b46253e07552">MagparFunctionInfoBegin</a>;
<a name="l00114"></a>00114 
<a name="l00115"></a>00115   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0; i&lt;nele; i++) {
<a name="l00116"></a>00116 
<a name="l00117"></a>00117     <span class="comment">/* Get Vertex coordinates */</span>
<a name="l00118"></a>00118     <span class="keywordtype">int</span> *t_v;
<a name="l00119"></a>00119     t_v=ele+i*<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>;
<a name="l00120"></a>00120 
<a name="l00121"></a>00121     x1=xyz+t_v[0]*<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>;
<a name="l00122"></a>00122     x2=xyz+t_v[1]*ND;
<a name="l00123"></a>00123     x3=xyz+t_v[2]*ND;
<a name="l00124"></a>00124     x4=xyz+t_v[3]*ND;
<a name="l00125"></a>00125 
<a name="l00126"></a>00126     <span class="comment">/* Calculate edge lengths */</span>
<a name="l00127"></a>00127     <a class="code" href="griddata_8h.html#aa89c56a68a27eb1d6913f275182ded8b">my_dcopy</a>(ND,x1,1,edge,1);
<a name="l00128"></a>00128     <a class="code" href="griddata_8h.html#af02ecaab36e7afb38d59a0967b2a04c5">my_daxpy</a>(ND,-1.0,x2,1,edge,1);
<a name="l00129"></a>00129     elen=<a class="code" href="griddata_8h.html#ab47b959efcd0f78b2f58b0afbd532141">my_dnrm2</a>(ND,edge,1);
<a name="l00130"></a>00130     elenmax=PetscMax(elenmax,elen);
<a name="l00131"></a>00131     elenmin=PetscMin(elenmin,elen);
<a name="l00132"></a>00132     elenavg += elen;
<a name="l00133"></a>00133 
<a name="l00134"></a>00134     <a class="code" href="griddata_8h.html#aa89c56a68a27eb1d6913f275182ded8b">my_dcopy</a>(ND,x1,1,edge,1);
<a name="l00135"></a>00135     <a class="code" href="griddata_8h.html#af02ecaab36e7afb38d59a0967b2a04c5">my_daxpy</a>(ND,-1.0,x3,1,edge,1);
<a name="l00136"></a>00136     elen=<a class="code" href="griddata_8h.html#ab47b959efcd0f78b2f58b0afbd532141">my_dnrm2</a>(ND,edge,1);
<a name="l00137"></a>00137     elenmax=PetscMax(elenmax,elen);
<a name="l00138"></a>00138     elenmin=PetscMin(elenmin,elen);
<a name="l00139"></a>00139     elenavg += elen;
<a name="l00140"></a>00140 
<a name="l00141"></a>00141     <a class="code" href="griddata_8h.html#aa89c56a68a27eb1d6913f275182ded8b">my_dcopy</a>(ND,x1,1,edge,1);
<a name="l00142"></a>00142     <a class="code" href="griddata_8h.html#af02ecaab36e7afb38d59a0967b2a04c5">my_daxpy</a>(ND,-1.0,x4,1,edge,1);
<a name="l00143"></a>00143     elen=<a class="code" href="griddata_8h.html#ab47b959efcd0f78b2f58b0afbd532141">my_dnrm2</a>(ND,edge,1);
<a name="l00144"></a>00144     elenmax=PetscMax(elenmax,elen);
<a name="l00145"></a>00145     elenmin=PetscMin(elenmin,elen);
<a name="l00146"></a>00146     elenavg += elen;
<a name="l00147"></a>00147 
<a name="l00148"></a>00148     <a class="code" href="griddata_8h.html#aa89c56a68a27eb1d6913f275182ded8b">my_dcopy</a>(ND,x2,1,edge,1);
<a name="l00149"></a>00149     <a class="code" href="griddata_8h.html#af02ecaab36e7afb38d59a0967b2a04c5">my_daxpy</a>(ND,-1.0,x3,1,edge,1);
<a name="l00150"></a>00150     elen=<a class="code" href="griddata_8h.html#ab47b959efcd0f78b2f58b0afbd532141">my_dnrm2</a>(ND,edge,1);
<a name="l00151"></a>00151     elenmax=PetscMax(elenmax,elen);
<a name="l00152"></a>00152     elenmin=PetscMin(elenmin,elen);
<a name="l00153"></a>00153     elenavg += elen;
<a name="l00154"></a>00154 
<a name="l00155"></a>00155     <a class="code" href="griddata_8h.html#aa89c56a68a27eb1d6913f275182ded8b">my_dcopy</a>(ND,x2,1,edge,1);
<a name="l00156"></a>00156     <a class="code" href="griddata_8h.html#af02ecaab36e7afb38d59a0967b2a04c5">my_daxpy</a>(ND,-1.0,x4,1,edge,1);
<a name="l00157"></a>00157     elen=<a class="code" href="griddata_8h.html#ab47b959efcd0f78b2f58b0afbd532141">my_dnrm2</a>(ND,edge,1);
<a name="l00158"></a>00158     elenmax=PetscMax(elenmax,elen);
<a name="l00159"></a>00159     elenmin=PetscMin(elenmin,elen);
<a name="l00160"></a>00160     elenavg += elen;
<a name="l00161"></a>00161 
<a name="l00162"></a>00162     <a class="code" href="griddata_8h.html#aa89c56a68a27eb1d6913f275182ded8b">my_dcopy</a>(ND,x3,1,edge,1);
<a name="l00163"></a>00163     <a class="code" href="griddata_8h.html#af02ecaab36e7afb38d59a0967b2a04c5">my_daxpy</a>(ND,-1.0,x4,1,edge,1);
<a name="l00164"></a>00164     elen=<a class="code" href="griddata_8h.html#ab47b959efcd0f78b2f58b0afbd532141">my_dnrm2</a>(ND,edge,1);
<a name="l00165"></a>00165     elenmax=PetscMax(elenmax,elen);
<a name="l00166"></a>00166     elenmin=PetscMin(elenmin,elen);
<a name="l00167"></a>00167     elenavg += elen;
<a name="l00168"></a>00168   }
<a name="l00169"></a>00169 
<a name="l00170"></a>00170   ierr = PetscGlobalMin(&amp;elenmin,min,PETSC_COMM_WORLD);CHKERRQ(ierr);
<a name="l00171"></a>00171   ierr = PetscGlobalMax(&amp;elenmax,max,PETSC_COMM_WORLD);CHKERRQ(ierr);
<a name="l00172"></a>00172   ierr = PetscGlobalSum(&amp;elenavg,avg,PETSC_COMM_WORLD);CHKERRQ(ierr);
<a name="l00173"></a>00173 
<a name="l00174"></a>00174   <a class="code" href="griddata_8h.html#a3a0efa409c6998ac8e9d7b30da6a8171">MagparFunctionInfoReturn</a>(0);
<a name="l00175"></a>00175 }
<a name="l00176"></a>00176 
<a name="l00177"></a>00177 
<a name="l00178"></a><a class="code" href="init_8h.html#a2103238be825fa27dce52bbc795d532d">00178</a> <span class="keywordtype">int</span> <a class="code" href="elevertvol_8c.html#a2103238be825fa27dce52bbc795d532d">EleVertVol</a>(<a class="code" href="structGridData.html">GridData</a> *gdata)
<a name="l00179"></a>00179 {
<a name="l00180"></a>00180   <a class="code" href="griddata_8h.html#a3d9da926137619fd02adb245a08536c7">MagparFunctionLogBegin</a>;
<a name="l00181"></a>00181 
<a name="l00182"></a>00182   <span class="keywordtype">int</span> rank,size;
<a name="l00183"></a>00183   ierr = MPI_Comm_size(PETSC_COMM_WORLD,&amp;size);CHKERRQ(ierr);
<a name="l00184"></a>00184   ierr = MPI_Comm_rank(PETSC_COMM_WORLD,&amp;rank);CHKERRQ(ierr);
<a name="l00185"></a>00185 
<a name="l00186"></a>00186   PetscReal *vprop;
<a name="l00187"></a>00187   ierr = PetscMalloc(gdata-&gt;<a class="code" href="structGridData.html#a4c7b7cea771dca3b63a4a37b0666ffc5">n_prop</a>*<span class="keyword">sizeof</span>(PetscReal),&amp;vprop);CHKERRQ(ierr);
<a name="l00188"></a>00188   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0;i&lt;gdata-&gt;<a class="code" href="structGridData.html#a4c7b7cea771dca3b63a4a37b0666ffc5">n_prop</a>;i++) {
<a name="l00189"></a>00189     vprop[i]=0.0;
<a name="l00190"></a>00190   }
<a name="l00191"></a>00191 
<a name="l00192"></a>00192   ierr = VecCreate(PETSC_COMM_WORLD,&amp;gdata-&gt;<a class="code" href="structGridData.html#a6415aba4002f4be8541f8f1ee7b9391d">elevol</a>);CHKERRQ(ierr);
<a name="l00193"></a>00193   ierr = VecSetSizes(gdata-&gt;<a class="code" href="structGridData.html#a6415aba4002f4be8541f8f1ee7b9391d">elevol</a>,gdata-&gt;<a class="code" href="structGridData.html#aa69a0b0a497df4cbeee604d3de4ff0b1">ln_ele</a>,gdata-&gt;<a class="code" href="structGridData.html#a45e64fa5ec485379f8171edbd95c79d9">n_ele</a>);CHKERRQ(ierr);
<a name="l00194"></a>00194   ierr = VecSetFromOptions(gdata-&gt;<a class="code" href="structGridData.html#a6415aba4002f4be8541f8f1ee7b9391d">elevol</a>);CHKERRQ(ierr);
<a name="l00195"></a>00195 
<a name="l00196"></a>00196   Vec elequal;
<a name="l00197"></a>00197   ierr = VecDuplicate(gdata-&gt;<a class="code" href="structGridData.html#a6415aba4002f4be8541f8f1ee7b9391d">elevol</a>,&amp;elequal);CHKERRQ(ierr);
<a name="l00198"></a>00198 
<a name="l00199"></a>00199   ierr = VecCreate(PETSC_COMM_WORLD,&amp;gdata-&gt;<a class="code" href="structGridData.html#a21683f539bbd0d68c0870cd0ece0de58">vertvol</a>);CHKERRQ(ierr);
<a name="l00200"></a>00200   ierr = VecSetSizes(gdata-&gt;<a class="code" href="structGridData.html#a21683f539bbd0d68c0870cd0ece0de58">vertvol</a>,gdata-&gt;<a class="code" href="structGridData.html#ae08e5326571671a361ae5d761d6ca672">ln_vert</a>,gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>);CHKERRQ(ierr);
<a name="l00201"></a>00201   ierr = VecSetFromOptions(gdata-&gt;<a class="code" href="structGridData.html#a21683f539bbd0d68c0870cd0ece0de58">vertvol</a>);CHKERRQ(ierr);
<a name="l00202"></a>00202 
<a name="l00203"></a>00203   ierr = VecDuplicate(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,&amp;gdata-&gt;<a class="code" href="structGridData.html#ac9ae4905283e303be4794e8f222086cb">VMs3</a>);CHKERRQ(ierr);
<a name="l00204"></a>00204 
<a name="l00205"></a>00205   PetscReal Javg=0.0;
<a name="l00206"></a>00206   PetscReal Vmag=0.0;
<a name="l00207"></a>00207   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0; i&lt;gdata-&gt;<a class="code" href="structGridData.html#aa69a0b0a497df4cbeee604d3de4ff0b1">ln_ele</a>; i++) {
<a name="l00208"></a>00208     <span class="comment">/* get vertex coordinates */</span>
<a name="l00209"></a>00209     <span class="keywordtype">int</span> *t_v;
<a name="l00210"></a>00210     t_v=gdata-&gt;<a class="code" href="structGridData.html#a8622e85fd1e5cf0dedd8960cc80f2e5c">elevert</a>+i*<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>;
<a name="l00211"></a>00211 
<a name="l00212"></a>00212     PetscReal *x1,*x2,*x3,*x4;
<a name="l00213"></a>00213     x1=gdata-&gt;<a class="code" href="structGridData.html#a1adbd5611aad877423d82c0ae9aae5ad">vertxyz</a>+t_v[0]*<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>;
<a name="l00214"></a>00214     x2=gdata-&gt;<a class="code" href="structGridData.html#a1adbd5611aad877423d82c0ae9aae5ad">vertxyz</a>+t_v[1]*ND;
<a name="l00215"></a>00215     x3=gdata-&gt;<a class="code" href="structGridData.html#a1adbd5611aad877423d82c0ae9aae5ad">vertxyz</a>+t_v[2]*ND;
<a name="l00216"></a>00216     x4=gdata-&gt;<a class="code" href="structGridData.html#a1adbd5611aad877423d82c0ae9aae5ad">vertxyz</a>+t_v[3]*ND;
<a name="l00217"></a>00217 
<a name="l00218"></a>00218     <span class="comment">/* get element volume */</span>
<a name="l00219"></a>00219     PetscReal T;
<a name="l00220"></a>00220     T=<a class="code" href="init_8h.html#ad362da888961433eb994e6a5bc0c818d">tetvol</a>(x1,x2,x3,x4);
<a name="l00221"></a>00221 
<a name="l00222"></a>00222     <span class="comment">/* fix elements with negative volume by switching node numbers */</span>
<a name="l00223"></a>00223     <span class="keywordflow">if</span> (T&lt;0.0) {
<a name="l00224"></a>00224 <span class="comment">/*</span>
<a name="l00225"></a>00225 <span class="comment">      PetscPrintf(PETSC_COMM_WORLD,</span>
<a name="l00226"></a>00226 <span class="comment">        &quot;element (local: %i, global: %i) (%i,%i,%i,%i) has negative volume - fixed!\n&quot;,</span>
<a name="l00227"></a>00227 <span class="comment">        i,gdata-&gt;elel2g[i],t_v[0],t_v[1],t_v[2],t_v[3]</span>
<a name="l00228"></a>00228 <span class="comment">      );</span>
<a name="l00229"></a>00229 <span class="comment">*/</span>
<a name="l00230"></a>00230       <span class="keywordtype">int</span> j;
<a name="l00231"></a>00231       j=t_v[0];
<a name="l00232"></a>00232       t_v[0]=t_v[1];
<a name="l00233"></a>00233       t_v[1]=j;
<a name="l00234"></a>00234       T=-T;
<a name="l00235"></a>00235 
<a name="l00236"></a>00236       x1=gdata-&gt;<a class="code" href="structGridData.html#a1adbd5611aad877423d82c0ae9aae5ad">vertxyz</a>+t_v[0]*ND;
<a name="l00237"></a>00237       x2=gdata-&gt;<a class="code" href="structGridData.html#a1adbd5611aad877423d82c0ae9aae5ad">vertxyz</a>+t_v[1]*ND;
<a name="l00238"></a>00238     }
<a name="l00239"></a>00239 
<a name="l00240"></a>00240     <span class="keywordflow">if</span> (gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*gdata-&gt;<a class="code" href="structGridData.html#add8d275e857e24934b4873e5746e49b1">eleprop</a>[i]+4]&gt;0.0) {
<a name="l00241"></a>00241       Vmag += T;
<a name="l00242"></a>00242     }
<a name="l00243"></a>00243 
<a name="l00244"></a>00244     ierr = VecSetValue(
<a name="l00245"></a>00245       gdata-&gt;<a class="code" href="structGridData.html#a6415aba4002f4be8541f8f1ee7b9391d">elevol</a>,
<a name="l00246"></a>00246       gdata-&gt;<a class="code" href="structGridData.html#a0ea3bd5c6e334d4f8c85dabd70cdf3ee">elel2g</a>[i],
<a name="l00247"></a>00247       T,
<a name="l00248"></a>00248       INSERT_VALUES
<a name="l00249"></a>00249     );CHKERRQ(ierr);
<a name="l00250"></a>00250 
<a name="l00251"></a>00251     <span class="keywordflow">for</span> (<span class="keywordtype">int</span> j=0;j&lt;NV;j++) {
<a name="l00252"></a>00252       ierr = VecSetValue(
<a name="l00253"></a>00253         gdata-&gt;<a class="code" href="structGridData.html#a21683f539bbd0d68c0870cd0ece0de58">vertvol</a>,
<a name="l00254"></a>00254         t_v[j],
<a name="l00255"></a>00255         T/NV,
<a name="l00256"></a>00256         ADD_VALUES
<a name="l00257"></a>00257       );CHKERRQ(ierr);
<a name="l00258"></a>00258 
<a name="l00259"></a>00259       PetscReal matele;
<a name="l00260"></a>00260       matele=T/NV*gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*gdata-&gt;<a class="code" href="structGridData.html#add8d275e857e24934b4873e5746e49b1">eleprop</a>[i]+4];
<a name="l00261"></a>00261       <span class="keywordflow">if</span> (PetscAbsReal(matele)&gt;<a class="code" href="griddata_8h.html#a26ab586dda1b8c780aa849e457c0cbad">D_EPS</a>) {
<a name="l00262"></a>00262         <span class="keywordflow">for</span> (<span class="keywordtype">int</span> k=0;k&lt;ND;k++) {
<a name="l00263"></a>00263           ierr = VecSetValue(
<a name="l00264"></a>00264             gdata-&gt;<a class="code" href="structGridData.html#ac9ae4905283e303be4794e8f222086cb">VMs3</a>,
<a name="l00265"></a>00265             gdata-&gt;<a class="code" href="structGridData.html#a8622e85fd1e5cf0dedd8960cc80f2e5c">elevert</a>[NV*i+j]*ND+k,
<a name="l00266"></a>00266             matele,
<a name="l00267"></a>00267             ADD_VALUES
<a name="l00268"></a>00268           );CHKERRQ(ierr);
<a name="l00269"></a>00269         }
<a name="l00270"></a>00270       }
<a name="l00271"></a>00271     }
<a name="l00272"></a>00272     Javg += T*gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*gdata-&gt;<a class="code" href="structGridData.html#add8d275e857e24934b4873e5746e49b1">eleprop</a>[i]+4]*gdata-&gt;<a class="code" href="structGridData.html#adef301a549db3735cb025a5088ee0db6">hscale</a>;
<a name="l00273"></a>00273     vprop[gdata-&gt;<a class="code" href="structGridData.html#add8d275e857e24934b4873e5746e49b1">eleprop</a>[i]] += T;
<a name="l00274"></a>00274 
<a name="l00275"></a>00275     PetscReal t_qual;
<a name="l00276"></a>00276     t_qual=<a class="code" href="elevertvol_8c.html#aef5a137b230e99388bfdb98e300fb741">tetqual</a>(x1,x2,x3,x4);
<a name="l00277"></a>00277     ierr = VecSetValue(
<a name="l00278"></a>00278       elequal,
<a name="l00279"></a>00279       gdata-&gt;<a class="code" href="structGridData.html#a0ea3bd5c6e334d4f8c85dabd70cdf3ee">elel2g</a>[i],
<a name="l00280"></a>00280       t_qual,
<a name="l00281"></a>00281       INSERT_VALUES
<a name="l00282"></a>00282     );CHKERRQ(ierr);
<a name="l00283"></a>00283   }
<a name="l00284"></a>00284 
<a name="l00285"></a>00285   ierr = VecAssemblyBegin(gdata-&gt;<a class="code" href="structGridData.html#a6415aba4002f4be8541f8f1ee7b9391d">elevol</a>);CHKERRQ(ierr);
<a name="l00286"></a>00286   ierr = VecAssemblyEnd(gdata-&gt;<a class="code" href="structGridData.html#a6415aba4002f4be8541f8f1ee7b9391d">elevol</a>);CHKERRQ(ierr);
<a name="l00287"></a>00287   ierr = VecAssemblyBegin(gdata-&gt;<a class="code" href="structGridData.html#a21683f539bbd0d68c0870cd0ece0de58">vertvol</a>);CHKERRQ(ierr);
<a name="l00288"></a>00288   ierr = VecAssemblyEnd(gdata-&gt;<a class="code" href="structGridData.html#a21683f539bbd0d68c0870cd0ece0de58">vertvol</a>);CHKERRQ(ierr);
<a name="l00289"></a>00289   ierr = VecAssemblyBegin(gdata-&gt;<a class="code" href="structGridData.html#ac9ae4905283e303be4794e8f222086cb">VMs3</a>);CHKERRQ(ierr);
<a name="l00290"></a>00290   ierr = VecAssemblyEnd(gdata-&gt;<a class="code" href="structGridData.html#ac9ae4905283e303be4794e8f222086cb">VMs3</a>);CHKERRQ(ierr);
<a name="l00291"></a>00291 
<a name="l00292"></a>00292   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0;i&lt;gdata-&gt;<a class="code" href="structGridData.html#a4c7b7cea771dca3b63a4a37b0666ffc5">n_prop</a>;i++) {
<a name="l00293"></a>00293     PetscReal temp;
<a name="l00294"></a>00294     ierr = PetscGlobalSum(&amp;vprop[i],&amp;temp,PETSC_COMM_WORLD);CHKERRQ(ierr);
<a name="l00295"></a>00295     vprop[i]=temp;
<a name="l00296"></a>00296   }
<a name="l00297"></a>00297 
<a name="l00298"></a>00298   <span class="comment">/* save *.felog --------------------------------------- */</span>
<a name="l00299"></a>00299 
<a name="l00300"></a>00300   <span class="keywordtype">char</span> fmesh[256];
<a name="l00301"></a>00301   FILE *fd;
<a name="l00302"></a>00302   ierr = PetscSNPrintf(fmesh,255,<span class="stringliteral">&quot;%s.%04i.%s&quot;</span>,gdata-&gt;<a class="code" href="structGridData.html#a2fba16fa768b0451df8fd12ed00a6c6b">simname</a>,gdata-&gt;<a class="code" href="structGridData.html#a4cc9b420611ac5eed22ee3bb2533fde4">inp</a>,<span class="stringliteral">&quot;felog&quot;</span>);CHKERRQ(ierr);
<a name="l00303"></a>00303   ierr = PetscFOpen(PETSC_COMM_WORLD,fmesh,<span class="stringliteral">&quot;w&quot;</span>,&amp;fd);CHKERRQ(ierr);
<a name="l00304"></a>00304   <span class="keywordflow">if</span> (!rank &amp;&amp; !fd) {
<a name="l00305"></a>00305     SETERRQ1(PETSC_ERR_FILE_OPEN,<span class="stringliteral">&quot;Cannot open %s\n&quot;</span>,fmesh);
<a name="l00306"></a>00306   }
<a name="l00307"></a>00307   PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;Opening file %s\n&quot;</span>,fmesh);
<a name="l00308"></a>00308 
<a name="l00309"></a>00309   <span class="comment">/* mesh stats --------------------------------------- */</span>
<a name="l00310"></a>00310 
<a name="l00311"></a>00311   ierr = PetscFPrintf(PETSC_COMM_WORLD,fd,
<a name="l00312"></a>00312     <span class="stringliteral">&quot;simname: %s\n&quot;</span>
<a name="l00313"></a>00313     <span class="stringliteral">&quot;n_vert:     %7d\n&quot;</span>
<a name="l00314"></a>00314     <span class="stringliteral">&quot;n_ele:      %7d\n&quot;</span>
<a name="l00315"></a>00315     <span class="stringliteral">&quot;n_vert_bnd: %7d\n&quot;</span>
<a name="l00316"></a>00316     <span class="stringliteral">&quot;n_bnd_fac:  %7d\n&quot;</span>
<a name="l00317"></a>00317     <span class="stringliteral">&quot;n_prop:     %7d\n&quot;</span>,
<a name="l00318"></a>00318     gdata-&gt;<a class="code" href="structGridData.html#a2fba16fa768b0451df8fd12ed00a6c6b">simname</a>,
<a name="l00319"></a>00319     gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>,
<a name="l00320"></a>00320     gdata-&gt;<a class="code" href="structGridData.html#a45e64fa5ec485379f8171edbd95c79d9">n_ele</a>,
<a name="l00321"></a>00321     gdata-&gt;<a class="code" href="structGridData.html#a916cbd12c058654799cd18db685734c5">n_vert_bnd</a>,
<a name="l00322"></a>00322     gdata-&gt;<a class="code" href="structGridData.html#a0d57327dd6a657273e24613f3edd7fce">n_bnd_fac</a>,
<a name="l00323"></a>00323     gdata-&gt;<a class="code" href="structGridData.html#a4c7b7cea771dca3b63a4a37b0666ffc5">n_prop</a>
<a name="l00324"></a>00324   );
<a name="l00325"></a>00325 
<a name="l00326"></a>00326   <span class="comment">/* bounding box --------------------------------------- */</span>
<a name="l00327"></a>00327   PetscReal   bbox[2*<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>];
<a name="l00328"></a>00328   <span class="keywordtype">int</span>         pid[1]={-1};
<a name="l00329"></a>00329 
<a name="l00330"></a>00330   ierr = <a class="code" href="calcbbox_8c.html#a7dcec04c75706920d2732ace5fe3bdf5">calcbbox</a>(gdata-&gt;<a class="code" href="structGridData.html#aa69a0b0a497df4cbeee604d3de4ff0b1">ln_ele</a>,gdata-&gt;<a class="code" href="structGridData.html#a8622e85fd1e5cf0dedd8960cc80f2e5c">elevert</a>,PETSC_NULL,gdata-&gt;<a class="code" href="structGridData.html#a1adbd5611aad877423d82c0ae9aae5ad">vertxyz</a>,1,pid,bbox);CHKERRQ(ierr);
<a name="l00331"></a>00331 
<a name="l00332"></a>00332   ierr = PetscFPrintf(PETSC_COMM_WORLD,fd,
<a name="l00333"></a>00333     <span class="stringliteral">&quot;\nbounding box: (%g,%g,%g) (%g,%g,%g)\n&quot;</span>,
<a name="l00334"></a>00334     bbox[0],bbox[1],bbox[2],
<a name="l00335"></a>00335     bbox[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>+0],bbox[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>+1],bbox[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>+2]
<a name="l00336"></a>00336   );CHKERRQ(ierr);
<a name="l00337"></a>00337 
<a name="l00338"></a>00338   <span class="comment">/* elevol --------------------------------------- */</span>
<a name="l00339"></a>00339 
<a name="l00340"></a>00340   PetscReal Vtot,Vmin,Vmax;
<a name="l00341"></a>00341   <span class="keywordtype">int</span> t_idxmin,t_idxmax;
<a name="l00342"></a>00342   ierr = VecMin(gdata-&gt;<a class="code" href="structGridData.html#a6415aba4002f4be8541f8f1ee7b9391d">elevol</a>,(<a class="code" href="griddata_8h.html#a515706180f960b30595b607f2d734d14" title="Contains all data to control the simulations.">PetscInt</a>*)&amp;t_idxmin,&amp;Vmin);CHKERRQ(ierr);
<a name="l00343"></a>00343   ierr = VecMax(gdata-&gt;<a class="code" href="structGridData.html#a6415aba4002f4be8541f8f1ee7b9391d">elevol</a>,(<a class="code" href="griddata_8h.html#a515706180f960b30595b607f2d734d14" title="Contains all data to control the simulations.">PetscInt</a>*)&amp;t_idxmax,&amp;Vmax);CHKERRQ(ierr);
<a name="l00344"></a>00344   ierr = VecSum(gdata-&gt;<a class="code" href="structGridData.html#a6415aba4002f4be8541f8f1ee7b9391d">elevol</a>,&amp;Vtot);CHKERRQ(ierr);
<a name="l00345"></a>00345   gdata-&gt;<a class="code" href="structGridData.html#a0ced0eaa5cb25c25363907973c7e69d6">totvol</a>=Vtot;
<a name="l00346"></a>00346 
<a name="l00347"></a>00347   ierr = PetscFPrintf(PETSC_COMM_WORLD,fd,
<a name="l00348"></a>00348     <span class="stringliteral">&quot;\nelevol:\n&quot;</span>
<a name="l00349"></a>00349     <span class="stringliteral">&quot;  id_min: %i\n&quot;</span>
<a name="l00350"></a>00350     <span class="stringliteral">&quot;  id_max: %i\n&quot;</span>
<a name="l00351"></a>00351     <span class="stringliteral">&quot;  Vmax:   %g\n&quot;</span>
<a name="l00352"></a>00352     <span class="stringliteral">&quot;  Vmin:   %g\n&quot;</span>
<a name="l00353"></a>00353     <span class="stringliteral">&quot;  ratio:  %g\n&quot;</span>
<a name="l00354"></a>00354     <span class="stringliteral">&quot;  Vavg:   %g\n&quot;</span>
<a name="l00355"></a>00355     <span class="stringliteral">&quot;  Vtot:   %g\n&quot;</span>,
<a name="l00356"></a>00356     t_idxmin,t_idxmax,Vmax,Vmin,Vmax/Vmin,Vtot/gdata-&gt;<a class="code" href="structGridData.html#a45e64fa5ec485379f8171edbd95c79d9">n_ele</a>,Vtot
<a name="l00357"></a>00357   );
<a name="l00358"></a>00358 
<a name="l00359"></a>00359   <span class="comment">/* vertvol --------------------------------------- */</span>
<a name="l00360"></a>00360 
<a name="l00361"></a>00361   ierr = VecMin(gdata-&gt;<a class="code" href="structGridData.html#a21683f539bbd0d68c0870cd0ece0de58">vertvol</a>,(<a class="code" href="griddata_8h.html#a515706180f960b30595b607f2d734d14" title="Contains all data to control the simulations.">PetscInt</a>*)&amp;t_idxmin,&amp;Vmin);CHKERRQ(ierr);
<a name="l00362"></a>00362   ierr = VecMax(gdata-&gt;<a class="code" href="structGridData.html#a21683f539bbd0d68c0870cd0ece0de58">vertvol</a>,(<a class="code" href="griddata_8h.html#a515706180f960b30595b607f2d734d14" title="Contains all data to control the simulations.">PetscInt</a>*)&amp;t_idxmax,&amp;Vmax);CHKERRQ(ierr);
<a name="l00363"></a>00363   ierr = VecSum(gdata-&gt;<a class="code" href="structGridData.html#a21683f539bbd0d68c0870cd0ece0de58">vertvol</a>,&amp;Vtot);CHKERRQ(ierr);
<a name="l00364"></a>00364 
<a name="l00365"></a>00365   <span class="comment">/* check that elevoltot == vertvoltot */</span>
<a name="l00366"></a>00366   assert(PetscAbsReal(gdata-&gt;<a class="code" href="structGridData.html#a0ced0eaa5cb25c25363907973c7e69d6">totvol</a>-Vtot) &lt; Vtot*1e-7);
<a name="l00367"></a>00367 
<a name="l00368"></a>00368   ierr = PetscFPrintf(PETSC_COMM_WORLD,fd,
<a name="l00369"></a>00369     <span class="stringliteral">&quot;\nvertvol:\n&quot;</span>
<a name="l00370"></a>00370     <span class="stringliteral">&quot;  id_min: %i\n&quot;</span>
<a name="l00371"></a>00371     <span class="stringliteral">&quot;  id_max: %i\n&quot;</span>
<a name="l00372"></a>00372     <span class="stringliteral">&quot;  Vmax:   %g\n&quot;</span>
<a name="l00373"></a>00373     <span class="stringliteral">&quot;  Vmin:   %g\n&quot;</span>
<a name="l00374"></a>00374     <span class="stringliteral">&quot;  ratio:  %g\n&quot;</span>
<a name="l00375"></a>00375     <span class="stringliteral">&quot;  Vavg:   %g\n&quot;</span>
<a name="l00376"></a>00376     <span class="stringliteral">&quot;  Vtot:   %g\n&quot;</span>,
<a name="l00377"></a>00377     t_idxmin,t_idxmax,Vmax,Vmin,Vmax/Vmin,Vtot/gdata-&gt;<a class="code" href="structGridData.html#a45e64fa5ec485379f8171edbd95c79d9">n_ele</a>,Vtot
<a name="l00378"></a>00378   );
<a name="l00379"></a>00379 
<a name="l00380"></a>00380   <span class="comment">/* edgestat --------------------------------------- */</span>
<a name="l00381"></a>00381 
<a name="l00382"></a>00382   PetscReal elenmax,elenmin,elenavg;
<a name="l00383"></a>00383   <a class="code" href="elevertvol_8c.html#a84b0acadfde91d8c984091ed850ab6bf">edgestat</a>(gdata-&gt;<a class="code" href="structGridData.html#aa69a0b0a497df4cbeee604d3de4ff0b1">ln_ele</a>,gdata-&gt;<a class="code" href="structGridData.html#a8622e85fd1e5cf0dedd8960cc80f2e5c">elevert</a>,gdata-&gt;<a class="code" href="structGridData.html#a1adbd5611aad877423d82c0ae9aae5ad">vertxyz</a>,&amp;elenmin,&amp;elenmax,&amp;elenavg);
<a name="l00384"></a>00384   elenavg /= 6*gdata-&gt;<a class="code" href="structGridData.html#a45e64fa5ec485379f8171edbd95c79d9">n_ele</a>;
<a name="l00385"></a>00385   ierr = PetscFPrintf(PETSC_COMM_WORLD,fd,
<a name="l00386"></a>00386     <span class="stringliteral">&quot;\n&quot;</span>
<a name="l00387"></a>00387     <span class="stringliteral">&quot;edge_len_min: %g\n&quot;</span>
<a name="l00388"></a>00388     <span class="stringliteral">&quot;edge_len_max: %g\n&quot;</span>
<a name="l00389"></a>00389     <span class="stringliteral">&quot;edge_len_avg: %g\n&quot;</span>,
<a name="l00390"></a>00390     elenmin,elenmax,elenavg
<a name="l00391"></a>00391   );
<a name="l00392"></a>00392   gdata-&gt;<a class="code" href="structGridData.html#a221b259fa149eef6f0982c2b6c9629f2">elenmax</a>=elenmax;
<a name="l00393"></a>00393 
<a name="l00394"></a>00394   <span class="comment">/* elequal --------------------------------------- */</span>
<a name="l00395"></a>00395 
<a name="l00396"></a>00396   <span class="comment">/* TODO: abusing Vmin, Vmax, Vtot */</span>
<a name="l00397"></a>00397   ierr = VecMin(elequal,(<a class="code" href="griddata_8h.html#a515706180f960b30595b607f2d734d14" title="Contains all data to control the simulations.">PetscInt</a>*)&amp;t_idxmin,&amp;Vmin);CHKERRQ(ierr);
<a name="l00398"></a>00398   ierr = VecMax(elequal,(<a class="code" href="griddata_8h.html#a515706180f960b30595b607f2d734d14" title="Contains all data to control the simulations.">PetscInt</a>*)&amp;t_idxmax,&amp;Vmax);CHKERRQ(ierr);
<a name="l00399"></a>00399   ierr = VecSum(elequal,&amp;Vtot);CHKERRQ(ierr);
<a name="l00400"></a>00400   ierr = PetscFPrintf(PETSC_COMM_WORLD,fd,
<a name="l00401"></a>00401     <span class="stringliteral">&quot;\nelequal:\n&quot;</span>
<a name="l00402"></a>00402     <span class="stringliteral">&quot;  min:    %g\n&quot;</span>
<a name="l00403"></a>00403     <span class="stringliteral">&quot;  max:    %g\n&quot;</span>
<a name="l00404"></a>00404     <span class="stringliteral">&quot;  avg:    %g\n&quot;</span>,
<a name="l00405"></a>00405     Vmin,Vmax,Vtot/gdata-&gt;<a class="code" href="structGridData.html#a45e64fa5ec485379f8171edbd95c79d9">n_ele</a>
<a name="l00406"></a>00406   );
<a name="l00407"></a>00407 
<a name="l00408"></a>00408   ierr = VecDestroy(elequal);CHKERRQ(ierr);
<a name="l00409"></a>00409 
<a name="l00410"></a>00410   <span class="comment">/* vol by prop --------------------------------------- */</span>
<a name="l00411"></a>00411 
<a name="l00412"></a>00412   Vtot=0.0;
<a name="l00413"></a>00413   ierr = PetscFPrintf(PETSC_COMM_WORLD,fd,
<a name="l00414"></a>00414     <span class="stringliteral">&quot;\nvolume by property id\n\n&quot;</span>
<a name="l00415"></a>00415     <span class="stringliteral">&quot;  pid | vol\n&quot;</span>
<a name="l00416"></a>00416     <span class="stringliteral">&quot;-----------\n&quot;</span>
<a name="l00417"></a>00417   );
<a name="l00418"></a>00418   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0;i&lt;gdata-&gt;<a class="code" href="structGridData.html#a4c7b7cea771dca3b63a4a37b0666ffc5">n_prop</a>;i++) {
<a name="l00419"></a>00419     ierr = PetscFPrintf(PETSC_COMM_WORLD,fd,
<a name="l00420"></a>00420       <span class="stringliteral">&quot;%5d   %g\n&quot;</span>,
<a name="l00421"></a>00421       i+1,vprop[i]
<a name="l00422"></a>00422     );
<a name="l00423"></a>00423     Vtot += vprop[i];
<a name="l00424"></a>00424   }
<a name="l00425"></a>00425   ierr = PetscFPrintf(PETSC_COMM_WORLD,fd,
<a name="l00426"></a>00426     <span class="stringliteral">&quot;-----------\n&quot;</span>
<a name="l00427"></a>00427     <span class="stringliteral">&quot;  sum = %g\n&quot;</span>,
<a name="l00428"></a>00428     Vtot
<a name="l00429"></a>00429   );
<a name="l00430"></a>00430 <span class="preprocessor">#ifdef PETSC_USE_SINGLE</span>
<a name="l00431"></a>00431 <span class="preprocessor"></span>  assert(PetscAbsReal(gdata-&gt;<a class="code" href="structGridData.html#a0ced0eaa5cb25c25363907973c7e69d6">totvol</a>-Vtot) &lt; Vtot*1e-3);
<a name="l00432"></a>00432 <span class="preprocessor">#else</span>
<a name="l00433"></a>00433 <span class="preprocessor"></span>  assert(PetscAbsReal(gdata-&gt;<a class="code" href="structGridData.html#a0ced0eaa5cb25c25363907973c7e69d6">totvol</a>-Vtot) &lt; Vtot*1e-7);
<a name="l00434"></a>00434 <span class="preprocessor">#endif</span>
<a name="l00435"></a>00435 <span class="preprocessor"></span>
<a name="l00436"></a>00436   <span class="comment">/* magnetic Vtot ------------------------------ */</span>
<a name="l00437"></a>00437 
<a name="l00438"></a>00438   ierr = PetscGlobalSum(&amp;Vmag,&amp;Vtot,PETSC_COMM_WORLD);CHKERRQ(ierr);
<a name="l00439"></a>00439   gdata-&gt;<a class="code" href="structGridData.html#a0ced0eaa5cb25c25363907973c7e69d6">totvol</a>=Vtot;
<a name="l00440"></a>00440 
<a name="l00441"></a>00441   <span class="comment">/* Javg --------------------------------------- */</span>
<a name="l00442"></a>00442 
<a name="l00443"></a>00443   PetscReal sum;
<a name="l00444"></a>00444   ierr = PetscGlobalSum(&amp;Javg,&amp;sum,PETSC_COMM_WORLD);CHKERRQ(ierr);
<a name="l00445"></a>00445   Javg=sum/Vtot;
<a name="l00446"></a>00446   ierr = PetscFPrintf(PETSC_COMM_WORLD,fd,
<a name="l00447"></a>00447     <span class="stringliteral">&quot;\naverage magnetization: %g T\n&quot;</span>,
<a name="l00448"></a>00448     Javg
<a name="l00449"></a>00449   );
<a name="l00450"></a>00450 
<a name="l00451"></a>00451   <span class="comment">/* done --------------------------------------- */</span>
<a name="l00452"></a>00452 
<a name="l00453"></a>00453   ierr = PetscFClose(PETSC_COMM_WORLD,fd);CHKERRQ(ierr);
<a name="l00454"></a>00454   ierr = PetscFree(vprop);CHKERRQ(ierr);
<a name="l00455"></a>00455 
<a name="l00456"></a>00456   <a class="code" href="griddata_8h.html#a8491466d8534a33d7163f5ea747e8210">MagparFunctionLogReturn</a>(0);
<a name="l00457"></a>00457 }
<a name="l00458"></a>00458 
</pre></div></div>
  <hr>
  <address>
    magpar - Parallel Finite Element Micromagnetics Package<br>
    Copyright (C) 2002-2010 Werner Scholz
  </address>
  </body>
</html>

